<html>
<head>
<title>OgreDataStream.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreDataStream.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreDataStream_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __DataStream_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __DataStream_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreSharedPtr_8h.html">OgreSharedPtr.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;istream&gt;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037     
<a name="l00040"></a>00040     <span class="keyword">template</span> &lt;<span class="keywordtype">size_t</span> cacheSize&gt;
<a name="l00041"></a><a class="code" href="classOgre_1_1StaticCache.html">00041</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1StaticCache.html" title="Template version of cache based on static array.">StaticCache</a>
<a name="l00042"></a>00042     {
<a name="l00043"></a>00043     <span class="keyword">protected</span>:
<a name="l00045"></a><a class="code" href="classOgre_1_1StaticCache.html#a26bae78964bd44c51a675f3159a10ae3">00045</a>         <span class="keywordtype">char</span> <a class="code" href="classOgre_1_1StaticCache.html#a26bae78964bd44c51a675f3159a10ae3" title="Static buffer.">mBuffer</a>[cacheSize];
<a name="l00046"></a>00046         
<a name="l00048"></a><a class="code" href="classOgre_1_1StaticCache.html#ae776876f275784304238426ebbe17110">00048</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1StaticCache.html#ae776876f275784304238426ebbe17110" title="Number of bytes valid in cache (written from the beginning of static buffer)">mValidBytes</a>;
<a name="l00050"></a><a class="code" href="classOgre_1_1StaticCache.html#a127f251105172f3487c603ba73fbd90f">00050</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1StaticCache.html#a127f251105172f3487c603ba73fbd90f" title="Current read position.">mPos</a>;
<a name="l00051"></a>00051         
<a name="l00052"></a>00052     <span class="keyword">public</span>:
<a name="l00054"></a><a class="code" href="classOgre_1_1StaticCache.html#a3e71993f421220f6d20a42c6c7401302">00054</a>         <a class="code" href="classOgre_1_1StaticCache.html#a3e71993f421220f6d20a42c6c7401302" title="Constructor.">StaticCache</a>()
<a name="l00055"></a>00055         {
<a name="l00056"></a>00056             <a class="code" href="classOgre_1_1StaticCache.html#ae776876f275784304238426ebbe17110" title="Number of bytes valid in cache (written from the beginning of static buffer)">mValidBytes</a> = 0;
<a name="l00057"></a>00057             <a class="code" href="classOgre_1_1StaticCache.html#a127f251105172f3487c603ba73fbd90f" title="Current read position.">mPos</a> = 0;
<a name="l00058"></a>00058         }
<a name="l00059"></a>00059         
<a name="l00062"></a><a class="code" href="classOgre_1_1StaticCache.html#a5b61f6d3a1c376811aedbd7718890d99">00062</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1StaticCache.html#a5b61f6d3a1c376811aedbd7718890d99" title="Cache data pointed by &#39;buf&#39;.">cacheData</a>(<span class="keyword">const</span> <span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> count)
<a name="l00063"></a>00063         {
<a name="l00064"></a>00064             assert(<a class="code" href="classOgre_1_1StaticCache.html#ae662e9d7744c0f70e8aa256b9403455b" title="Returns number of bytes available for reading in cache after rewinding.">avail</a>() == 0 &amp;&amp; <span class="stringliteral">&quot;It is assumed that you cache data only after you have read everything.&quot;</span>);
<a name="l00065"></a>00065             
<a name="l00066"></a>00066             <span class="keywordflow">if</span> (count &lt; cacheSize)
<a name="l00067"></a>00067             {
<a name="l00068"></a>00068                 <span class="comment">// number of bytes written is less than total size of cache</span>
<a name="l00069"></a>00069                 <span class="keywordflow">if</span> (count + <a class="code" href="classOgre_1_1StaticCache.html#ae776876f275784304238426ebbe17110" title="Number of bytes valid in cache (written from the beginning of static buffer)">mValidBytes</a> &lt;= cacheSize)
<a name="l00070"></a>00070                 {
<a name="l00071"></a>00071                     <span class="comment">// just append</span>
<a name="l00072"></a>00072                     memcpy(<a class="code" href="classOgre_1_1StaticCache.html#a26bae78964bd44c51a675f3159a10ae3" title="Static buffer.">mBuffer</a> + <a class="code" href="classOgre_1_1StaticCache.html#ae776876f275784304238426ebbe17110" title="Number of bytes valid in cache (written from the beginning of static buffer)">mValidBytes</a>, buf, count);
<a name="l00073"></a>00073                     <a class="code" href="classOgre_1_1StaticCache.html#ae776876f275784304238426ebbe17110" title="Number of bytes valid in cache (written from the beginning of static buffer)">mValidBytes</a> += count;
<a name="l00074"></a>00074                 }
<a name="l00075"></a>00075                 <span class="keywordflow">else</span>
<a name="l00076"></a>00076                 {
<a name="l00077"></a>00077                     <span class="keywordtype">size_t</span> begOff = count - (cacheSize - <a class="code" href="classOgre_1_1StaticCache.html#ae776876f275784304238426ebbe17110" title="Number of bytes valid in cache (written from the beginning of static buffer)">mValidBytes</a>);
<a name="l00078"></a>00078                     <span class="comment">// override old cache content in the beginning</span>
<a name="l00079"></a>00079                     memmove(<a class="code" href="classOgre_1_1StaticCache.html#a26bae78964bd44c51a675f3159a10ae3" title="Static buffer.">mBuffer</a>, <a class="code" href="classOgre_1_1StaticCache.html#a26bae78964bd44c51a675f3159a10ae3" title="Static buffer.">mBuffer</a> + begOff, <a class="code" href="classOgre_1_1StaticCache.html#ae776876f275784304238426ebbe17110" title="Number of bytes valid in cache (written from the beginning of static buffer)">mValidBytes</a> - begOff);
<a name="l00080"></a>00080                     <span class="comment">// append new data</span>
<a name="l00081"></a>00081                     memcpy(<a class="code" href="classOgre_1_1StaticCache.html#a26bae78964bd44c51a675f3159a10ae3" title="Static buffer.">mBuffer</a> + cacheSize - count, buf, count);
<a name="l00082"></a>00082                     <a class="code" href="classOgre_1_1StaticCache.html#ae776876f275784304238426ebbe17110" title="Number of bytes valid in cache (written from the beginning of static buffer)">mValidBytes</a> = cacheSize;
<a name="l00083"></a>00083                 }
<a name="l00084"></a>00084                 <a class="code" href="classOgre_1_1StaticCache.html#a127f251105172f3487c603ba73fbd90f" title="Current read position.">mPos</a> = <a class="code" href="classOgre_1_1StaticCache.html#ae776876f275784304238426ebbe17110" title="Number of bytes valid in cache (written from the beginning of static buffer)">mValidBytes</a>;
<a name="l00085"></a>00085                 <span class="keywordflow">return</span> count;
<a name="l00086"></a>00086             }
<a name="l00087"></a>00087             <span class="keywordflow">else</span>
<a name="l00088"></a>00088             {
<a name="l00089"></a>00089                 <span class="comment">// discard all</span>
<a name="l00090"></a>00090                 memcpy(<a class="code" href="classOgre_1_1StaticCache.html#a26bae78964bd44c51a675f3159a10ae3" title="Static buffer.">mBuffer</a>, (<span class="keyword">const</span> <span class="keywordtype">char</span>*)buf + count - cacheSize, cacheSize);
<a name="l00091"></a>00091                 <a class="code" href="classOgre_1_1StaticCache.html#ae776876f275784304238426ebbe17110" title="Number of bytes valid in cache (written from the beginning of static buffer)">mValidBytes</a> = <a class="code" href="classOgre_1_1StaticCache.html#a127f251105172f3487c603ba73fbd90f" title="Current read position.">mPos</a> = cacheSize;
<a name="l00092"></a>00092                 <span class="keywordflow">return</span> cacheSize;
<a name="l00093"></a>00093             }
<a name="l00094"></a>00094         }
<a name="l00096"></a><a class="code" href="classOgre_1_1StaticCache.html#a98387ba5e5f61b22c0933ed2f3dfb303">00096</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1StaticCache.html#a98387ba5e5f61b22c0933ed2f3dfb303" title="Read data from cache to &#39;buf&#39; (maximum &#39;count&#39; bytes).">read</a>(<span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> count)
<a name="l00097"></a>00097         {
<a name="l00098"></a>00098             <span class="keywordtype">size_t</span> rb = <a class="code" href="classOgre_1_1StaticCache.html#ae662e9d7744c0f70e8aa256b9403455b" title="Returns number of bytes available for reading in cache after rewinding.">avail</a>();
<a name="l00099"></a>00099             rb = (rb &lt; count) ? rb : count;
<a name="l00100"></a>00100             memcpy(buf, <a class="code" href="classOgre_1_1StaticCache.html#a26bae78964bd44c51a675f3159a10ae3" title="Static buffer.">mBuffer</a> + <a class="code" href="classOgre_1_1StaticCache.html#a127f251105172f3487c603ba73fbd90f" title="Current read position.">mPos</a>, rb);
<a name="l00101"></a>00101             <a class="code" href="classOgre_1_1StaticCache.html#a127f251105172f3487c603ba73fbd90f" title="Current read position.">mPos</a> += rb;
<a name="l00102"></a>00102             <span class="keywordflow">return</span> rb;
<a name="l00103"></a>00103         }
<a name="l00104"></a>00104         
<a name="l00106"></a><a class="code" href="classOgre_1_1StaticCache.html#a391ccc42df8e159a6b5dd7da49ac1679">00106</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1StaticCache.html#a391ccc42df8e159a6b5dd7da49ac1679" title="Step back in cached stream by &#39;count&#39; bytes.">rewind</a>(<span class="keywordtype">size_t</span> count)
<a name="l00107"></a>00107         {
<a name="l00108"></a>00108             <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1StaticCache.html#a127f251105172f3487c603ba73fbd90f" title="Current read position.">mPos</a> &lt; count)
<a name="l00109"></a>00109             {
<a name="l00110"></a>00110                 <a class="code" href="classOgre_1_1StaticCache.html#abf9d854f82e9e25fb410be84941890ee" title="Clear the cache.">clear</a>();
<a name="l00111"></a>00111                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00112"></a>00112             }
<a name="l00113"></a>00113             <span class="keywordflow">else</span>
<a name="l00114"></a>00114             {
<a name="l00115"></a>00115                 <a class="code" href="classOgre_1_1StaticCache.html#a127f251105172f3487c603ba73fbd90f" title="Current read position.">mPos</a> -= count;
<a name="l00116"></a>00116                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00117"></a>00117             }
<a name="l00118"></a>00118         }
<a name="l00120"></a><a class="code" href="classOgre_1_1StaticCache.html#a0c5c50ba8dcb899f95414093f1085789">00120</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1StaticCache.html#a0c5c50ba8dcb899f95414093f1085789" title="Step forward in cached stream by &#39;count&#39; bytes.">ff</a>(<span class="keywordtype">size_t</span> count)
<a name="l00121"></a>00121         {
<a name="l00122"></a>00122             <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1StaticCache.html#ae662e9d7744c0f70e8aa256b9403455b" title="Returns number of bytes available for reading in cache after rewinding.">avail</a>() &lt; count)
<a name="l00123"></a>00123             {
<a name="l00124"></a>00124                 <a class="code" href="classOgre_1_1StaticCache.html#abf9d854f82e9e25fb410be84941890ee" title="Clear the cache.">clear</a>();
<a name="l00125"></a>00125                 <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00126"></a>00126             }
<a name="l00127"></a>00127             <span class="keywordflow">else</span>
<a name="l00128"></a>00128             {
<a name="l00129"></a>00129                 <a class="code" href="classOgre_1_1StaticCache.html#a127f251105172f3487c603ba73fbd90f" title="Current read position.">mPos</a> += count;
<a name="l00130"></a>00130                 <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00131"></a>00131             }
<a name="l00132"></a>00132         }
<a name="l00133"></a>00133         
<a name="l00135"></a><a class="code" href="classOgre_1_1StaticCache.html#ae662e9d7744c0f70e8aa256b9403455b">00135</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1StaticCache.html#ae662e9d7744c0f70e8aa256b9403455b" title="Returns number of bytes available for reading in cache after rewinding.">avail</a>()<span class="keyword"> const</span>
<a name="l00136"></a>00136 <span class="keyword">        </span>{
<a name="l00137"></a>00137             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1StaticCache.html#ae776876f275784304238426ebbe17110" title="Number of bytes valid in cache (written from the beginning of static buffer)">mValidBytes</a> - <a class="code" href="classOgre_1_1StaticCache.html#a127f251105172f3487c603ba73fbd90f" title="Current read position.">mPos</a>;
<a name="l00138"></a>00138         }
<a name="l00139"></a>00139         
<a name="l00141"></a><a class="code" href="classOgre_1_1StaticCache.html#abf9d854f82e9e25fb410be84941890ee">00141</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1StaticCache.html#abf9d854f82e9e25fb410be84941890ee" title="Clear the cache.">clear</a>()
<a name="l00142"></a>00142         {
<a name="l00143"></a>00143             <a class="code" href="classOgre_1_1StaticCache.html#ae776876f275784304238426ebbe17110" title="Number of bytes valid in cache (written from the beginning of static buffer)">mValidBytes</a> = 0;
<a name="l00144"></a>00144             <a class="code" href="classOgre_1_1StaticCache.html#a127f251105172f3487c603ba73fbd90f" title="Current read position.">mPos</a> = 0;
<a name="l00145"></a>00145         }
<a name="l00146"></a>00146     };
<a name="l00147"></a>00147     
<a name="l00148"></a>00148     
<a name="l00175"></a><a class="code" href="classOgre_1_1DataStream.html">00175</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading and writing of data.">DataStream</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">StreamAlloc</a>
<a name="l00176"></a>00176     {
<a name="l00177"></a>00177     <span class="keyword">public</span>:
<a name="l00178"></a><a class="code" href="classOgre_1_1DataStream.html#a81856582e643b4a560e6c3d3ad05e08c">00178</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1DataStream.html#a81856582e643b4a560e6c3d3ad05e08c">AccessMode</a>
<a name="l00179"></a>00179         {
<a name="l00180"></a><a class="code" href="classOgre_1_1DataStream.html#a81856582e643b4a560e6c3d3ad05e08cac5f9d1587e9cc7dd1577af114dcba50e">00180</a>             READ = 1, 
<a name="l00181"></a><a class="code" href="classOgre_1_1DataStream.html#a81856582e643b4a560e6c3d3ad05e08ca8e221ca82d405d21d275997fbd3eb900">00181</a>             WRITE = 2
<a name="l00182"></a>00182         };
<a name="l00183"></a>00183     <span class="keyword">protected</span>:
<a name="l00185"></a><a class="code" href="classOgre_1_1DataStream.html#a371660702e913ca2799f0478a2154af7">00185</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1DataStream.html#a371660702e913ca2799f0478a2154af7" title="The name (e.g. resource name) that can be used to identify the source fot his data (optional)...">mName</a>;       
<a name="l00187"></a><a class="code" href="classOgre_1_1DataStream.html#a260d2aa9971abc5b8412cff1a01d6382">00187</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1DataStream.html#a260d2aa9971abc5b8412cff1a01d6382" title="Size of the data in the stream (may be 0 if size cannot be determined)">mSize</a>;
<a name="l00189"></a><a class="code" href="classOgre_1_1DataStream.html#a8eab8765fb7120bb1e519ff8d2460b13">00189</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1DataStream.html#a8eab8765fb7120bb1e519ff8d2460b13" title="What type of access is allowed (AccessMode)">mAccess</a>;
<a name="l00190"></a>00190 
<a name="l00191"></a><a class="code" href="OgreDataStream_8h.html#a71a2d398037a64aa241ef5c0be350430">00191</a> <span class="preprocessor">        #define OGRE_STREAM_TEMP_SIZE 128</span>
<a name="l00192"></a>00192 <span class="preprocessor"></span>    <span class="keyword">public</span>:
<a name="l00194"></a><a class="code" href="classOgre_1_1DataStream.html#a87d6018d4486304f004782c536a72de5">00194</a>         <a class="code" href="classOgre_1_1DataStream.html#a87d6018d4486304f004782c536a72de5" title="Constructor for creating unnamed streams.">DataStream</a>(<a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> accessMode = READ) : mSize(0), mAccess(accessMode) {}
<a name="l00196"></a><a class="code" href="classOgre_1_1DataStream.html#a679e39a3ef590e1dc232800c37cfeb8b">00196</a>         <a class="code" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading and writing of data.">DataStream</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> accessMode = READ) 
<a name="l00197"></a>00197             : mName(name), mSize(0), mAccess(accessMode) {}
<a name="l00199"></a><a class="code" href="classOgre_1_1DataStream.html#a7ebd86825f86b7114024d168e9751395">00199</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1DataStream.html#a7ebd86825f86b7114024d168e9751395" title="Returns the name of the stream, if it has one.">getName</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mName; }
<a name="l00201"></a><a class="code" href="classOgre_1_1DataStream.html#a5c83611aecda5358beb6c6e035f33b51">00201</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1DataStream.html#a5c83611aecda5358beb6c6e035f33b51" title="Gets the access mode of the stream.">getAccessMode</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mAccess; }
<a name="l00203"></a><a class="code" href="classOgre_1_1DataStream.html#a4779f7f57ff90ce12882c7c891651a71">00203</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1DataStream.html#a4779f7f57ff90ce12882c7c891651a71" title="Reports whether this stream is readable.">isReadable</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (mAccess &amp; READ) != 0; }
<a name="l00205"></a><a class="code" href="classOgre_1_1DataStream.html#a91509b9cec70111c65570883810224be">00205</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1DataStream.html#a91509b9cec70111c65570883810224be" title="Reports whether this stream is writeable.">isWriteable</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (mAccess &amp; WRITE) != 0; }
<a name="l00206"></a><a class="code" href="classOgre_1_1DataStream.html#a9501eeeb1aefc59f4dad05ec0cbdc14e">00206</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1DataStream.html#a9501eeeb1aefc59f4dad05ec0cbdc14e">~DataStream</a>() {}
<a name="l00207"></a>00207         <span class="comment">// Streaming operators</span>
<a name="l00208"></a>00208         <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; <a class="code" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading and writing of data.">DataStream</a>&amp; operator&gt;&gt;(T&amp; val);
<a name="l00215"></a>00215         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> read(<span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> count) = 0;
<a name="l00222"></a><a class="code" href="classOgre_1_1DataStream.html#a68cde598ee9c2694e16931134fe5c136">00222</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> write(<span class="keyword">const</span> <span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> count)
<a name="l00223"></a>00223         {
<a name="l00224"></a>00224                         (void)buf;
<a name="l00225"></a>00225                         (void)count;
<a name="l00226"></a>00226             <span class="comment">// default to not supported</span>
<a name="l00227"></a>00227             <span class="keywordflow">return</span> 0;
<a name="l00228"></a>00228         }
<a name="l00229"></a>00229 
<a name="l00244"></a>00244         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> readLine(<span class="keywordtype">char</span>* buf, <span class="keywordtype">size_t</span> maxCount, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; delim = <span class="stringliteral">&quot;\n&quot;</span>);
<a name="l00245"></a>00245         
<a name="l00260"></a>00260         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getLine( <span class="keywordtype">bool</span> trimAfter = <span class="keyword">true</span> );
<a name="l00261"></a>00261 
<a name="l00267"></a>00267         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getAsString(<span class="keywordtype">void</span>);
<a name="l00268"></a>00268 
<a name="l00276"></a>00276         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> skipLine(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; delim = <span class="stringliteral">&quot;\n&quot;</span>);
<a name="l00277"></a>00277 
<a name="l00280"></a>00280         <span class="keyword">virtual</span> <span class="keywordtype">void</span> skip(<span class="keywordtype">long</span> count) = 0;
<a name="l00281"></a>00281     
<a name="l00284"></a>00284         <span class="keyword">virtual</span> <span class="keywordtype">void</span> seek( <span class="keywordtype">size_t</span> pos ) = 0;
<a name="l00285"></a>00285         
<a name="l00287"></a>00287         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> tell(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00288"></a>00288 
<a name="l00291"></a>00291         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> eof(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00292"></a>00292 
<a name="l00296"></a><a class="code" href="classOgre_1_1DataStream.html#a1d4e9568e53a8071ea9b29a015425aef">00296</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1DataStream.html#a1d4e9568e53a8071ea9b29a015425aef" title="Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this...">size</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSize; }
<a name="l00297"></a>00297 
<a name="l00299"></a>00299         <span class="keyword">virtual</span> <span class="keywordtype">void</span> close(<span class="keywordtype">void</span>) = 0;
<a name="l00300"></a>00300         
<a name="l00301"></a>00301 
<a name="l00302"></a>00302     };
<a name="l00303"></a>00303 
<a name="l00307"></a><a class="code" href="group__Resources.html#ga8a2a961b4205aacff9c01e81e08d7781">00307</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html">SharedPtr&lt;DataStream&gt;</a> <a class="code" href="group__Resources.html#ga8a2a961b4205aacff9c01e81e08d7781" title="Shared pointer to allow data streams to be passed around without worrying about deallocation.">DataStreamPtr</a>;
<a name="l00308"></a>00308 
<a name="l00310"></a><a class="code" href="group__Resources.html#gaf30cff05594c7346e6f7bb0ec48aa597">00310</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html#ac64759673476a6852c0a09e1acec2a8c">list&lt;DataStreamPtr&gt;::type</a> <a class="code" href="group__Resources.html#gaf30cff05594c7346e6f7bb0ec48aa597" title="List of DataStream items.">DataStreamList</a>;
<a name="l00312"></a><a class="code" href="group__Resources.html#gaca357d60ac34de84a39467c1f557749e">00312</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;DataStreamList&gt;</a> <a class="code" href="group__Resources.html#gaca357d60ac34de84a39467c1f557749e" title="Shared pointer to list of DataStream items.">DataStreamListPtr</a>;
<a name="l00313"></a>00313 
<a name="l00316"></a><a class="code" href="classOgre_1_1MemoryDataStream.html">00316</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1MemoryDataStream.html" title="Common subclass of DataStream for handling data from chunks of memory.">MemoryDataStream</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading and writing of data.">DataStream</a>
<a name="l00317"></a>00317     {
<a name="l00318"></a>00318     <span class="keyword">protected</span>:
<a name="l00320"></a><a class="code" href="classOgre_1_1MemoryDataStream.html#a031fc2b8dde9f716e0d3b32b53c9c46c">00320</a>         <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>* <a class="code" href="classOgre_1_1MemoryDataStream.html#a031fc2b8dde9f716e0d3b32b53c9c46c" title="Pointer to the start of the data area.">mData</a>;
<a name="l00322"></a><a class="code" href="classOgre_1_1MemoryDataStream.html#acf8096ff658fc9016c6cce0d28377b8a">00322</a>         <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>* <a class="code" href="classOgre_1_1MemoryDataStream.html#acf8096ff658fc9016c6cce0d28377b8a" title="Pointer to the current position in the memory.">mPos</a>;
<a name="l00324"></a><a class="code" href="classOgre_1_1MemoryDataStream.html#a529afac3f0ee55d00798f3ef7058a94f">00324</a>         <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>* <a class="code" href="classOgre_1_1MemoryDataStream.html#a529afac3f0ee55d00798f3ef7058a94f" title="Pointer to the end of the memory.">mEnd</a>;
<a name="l00326"></a><a class="code" href="classOgre_1_1MemoryDataStream.html#a1099feda84559859d0e73ccf3589d4a4">00326</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1MemoryDataStream.html#a1099feda84559859d0e73ccf3589d4a4" title="Do we delete the memory on close.">mFreeOnClose</a>;          
<a name="l00327"></a>00327     <span class="keyword">public</span>:
<a name="l00328"></a>00328         
<a name="l00339"></a>00339         <a class="code" href="classOgre_1_1MemoryDataStream.html" title="Common subclass of DataStream for handling data from chunks of memory.">MemoryDataStream</a>(<span class="keywordtype">void</span>* pMem, <span class="keywordtype">size_t</span> size, <span class="keywordtype">bool</span> freeOnClose = <span class="keyword">false</span>, <span class="keywordtype">bool</span> readOnly = <span class="keyword">false</span>);
<a name="l00340"></a>00340         
<a name="l00352"></a>00352         <a class="code" href="classOgre_1_1MemoryDataStream.html" title="Common subclass of DataStream for handling data from chunks of memory.">MemoryDataStream</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">void</span>* pMem, <span class="keywordtype">size_t</span> size, 
<a name="l00353"></a>00353                 <span class="keywordtype">bool</span> freeOnClose = <span class="keyword">false</span>, <span class="keywordtype">bool</span> readOnly = <span class="keyword">false</span>);
<a name="l00354"></a>00354 
<a name="l00366"></a>00366         <a class="code" href="classOgre_1_1MemoryDataStream.html" title="Common subclass of DataStream for handling data from chunks of memory.">MemoryDataStream</a>(<a class="code" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading and writing of data.">DataStream</a>&amp; sourceStream, 
<a name="l00367"></a>00367                 <span class="keywordtype">bool</span> freeOnClose = <span class="keyword">true</span>, <span class="keywordtype">bool</span> readOnly = <span class="keyword">false</span>);
<a name="l00368"></a>00368         
<a name="l00380"></a>00380         <a class="code" href="classOgre_1_1MemoryDataStream.html" title="Common subclass of DataStream for handling data from chunks of memory.">MemoryDataStream</a>(<a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; sourceStream, 
<a name="l00381"></a>00381                 <span class="keywordtype">bool</span> freeOnClose = <span class="keyword">true</span>, <span class="keywordtype">bool</span> readOnly = <span class="keyword">false</span>);
<a name="l00382"></a>00382 
<a name="l00396"></a>00396         <a class="code" href="classOgre_1_1MemoryDataStream.html" title="Common subclass of DataStream for handling data from chunks of memory.">MemoryDataStream</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading and writing of data.">DataStream</a>&amp; sourceStream, 
<a name="l00397"></a>00397                 <span class="keywordtype">bool</span> freeOnClose = <span class="keyword">true</span>, <span class="keywordtype">bool</span> readOnly = <span class="keyword">false</span>);
<a name="l00398"></a>00398 
<a name="l00412"></a>00412         <a class="code" href="classOgre_1_1MemoryDataStream.html" title="Common subclass of DataStream for handling data from chunks of memory.">MemoryDataStream</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; sourceStream, 
<a name="l00413"></a>00413             <span class="keywordtype">bool</span> freeOnClose = <span class="keyword">true</span>, <span class="keywordtype">bool</span> readOnly = <span class="keyword">false</span>);
<a name="l00414"></a>00414 
<a name="l00421"></a>00421         <a class="code" href="classOgre_1_1MemoryDataStream.html" title="Common subclass of DataStream for handling data from chunks of memory.">MemoryDataStream</a>(<span class="keywordtype">size_t</span> size, <span class="keywordtype">bool</span> freeOnClose = <span class="keyword">true</span>, <span class="keywordtype">bool</span> readOnly = <span class="keyword">false</span>);
<a name="l00429"></a>00429         <a class="code" href="classOgre_1_1MemoryDataStream.html" title="Common subclass of DataStream for handling data from chunks of memory.">MemoryDataStream</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">size_t</span> size, 
<a name="l00430"></a>00430                 <span class="keywordtype">bool</span> freeOnClose = <span class="keyword">true</span>, <span class="keywordtype">bool</span> readOnly = <span class="keyword">false</span>);
<a name="l00431"></a>00431 
<a name="l00432"></a>00432         ~<a class="code" href="classOgre_1_1MemoryDataStream.html" title="Common subclass of DataStream for handling data from chunks of memory.">MemoryDataStream</a>();
<a name="l00433"></a>00433 
<a name="l00435"></a><a class="code" href="classOgre_1_1MemoryDataStream.html#a9d866cd1bbe58bbc59fdbc1dba024b9f">00435</a>         <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>* <a class="code" href="classOgre_1_1MemoryDataStream.html#a9d866cd1bbe58bbc59fdbc1dba024b9f" title="Get a pointer to the start of the memory block this stream holds.">getPtr</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mData; }
<a name="l00436"></a>00436         
<a name="l00438"></a><a class="code" href="classOgre_1_1MemoryDataStream.html#ac753e2375fcdf5e137210339350b5f21">00438</a>         <a class="code" href="namespaceOgre.html#a07f1f7c1d84d58c9beae02e1ebb945e4" title="In order to avoid finger-aches :)">uchar</a>* <a class="code" href="classOgre_1_1MemoryDataStream.html#ac753e2375fcdf5e137210339350b5f21" title="Get a pointer to the current position in the memory block this stream holds.">getCurrentPtr</a>(<span class="keywordtype">void</span>) { <span class="keywordflow">return</span> mPos; }
<a name="l00439"></a>00439         
<a name="l00442"></a>00442         <span class="keywordtype">size_t</span> read(<span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> count);
<a name="l00443"></a>00443 
<a name="l00446"></a>00446         <span class="keywordtype">size_t</span> write(<span class="keyword">const</span> <span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> count);
<a name="l00447"></a>00447 
<a name="l00450"></a>00450         <span class="keywordtype">size_t</span> readLine(<span class="keywordtype">char</span>* buf, <span class="keywordtype">size_t</span> maxCount, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; delim = <span class="stringliteral">&quot;\n&quot;</span>);
<a name="l00451"></a>00451         
<a name="l00454"></a>00454         <span class="keywordtype">size_t</span> skipLine(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; delim = <span class="stringliteral">&quot;\n&quot;</span>);
<a name="l00455"></a>00455 
<a name="l00458"></a>00458         <span class="keywordtype">void</span> skip(<span class="keywordtype">long</span> count);
<a name="l00459"></a>00459     
<a name="l00462"></a>00462         <span class="keywordtype">void</span> seek( <span class="keywordtype">size_t</span> pos );
<a name="l00463"></a>00463         
<a name="l00466"></a>00466         <span class="keywordtype">size_t</span> tell(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00467"></a>00467 
<a name="l00470"></a>00470         <span class="keywordtype">bool</span> eof(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00471"></a>00471 
<a name="l00474"></a>00474         <span class="keywordtype">void</span> close(<span class="keywordtype">void</span>);
<a name="l00475"></a>00475 
<a name="l00477"></a><a class="code" href="classOgre_1_1MemoryDataStream.html#acee80421c052bd3c6452141f067cfa13">00477</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1MemoryDataStream.html#acee80421c052bd3c6452141f067cfa13" title="Sets whether or not to free the encapsulated memory on close.">setFreeOnClose</a>(<span class="keywordtype">bool</span> free) { mFreeOnClose = free; }
<a name="l00478"></a>00478     };
<a name="l00479"></a>00479 
<a name="l00483"></a><a class="code" href="group__Resources.html#gaf8656a2c0ef06642f70c4b3745ee80a2">00483</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;MemoryDataStream&gt;</a> <a class="code" href="group__Resources.html#gaf8656a2c0ef06642f70c4b3745ee80a2" title="Shared pointer to allow memory data streams to be passed around without worrying about deallocation...">MemoryDataStreamPtr</a>;
<a name="l00484"></a>00484 
<a name="l00488"></a><a class="code" href="classOgre_1_1FileStreamDataStream.html">00488</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1FileStreamDataStream.html" title="Common subclass of DataStream for handling data from std::basic_istream.">FileStreamDataStream</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading and writing of data.">DataStream</a>
<a name="l00489"></a>00489     {
<a name="l00490"></a>00490     <span class="keyword">protected</span>:
<a name="l00492"></a><a class="code" href="classOgre_1_1FileStreamDataStream.html#a9866d52afa2ee74462a144392a50c4e1">00492</a>         std::istream* <a class="code" href="classOgre_1_1FileStreamDataStream.html#a9866d52afa2ee74462a144392a50c4e1" title="Reference to source stream (read)">mInStream</a>;
<a name="l00494"></a><a class="code" href="classOgre_1_1FileStreamDataStream.html#af68c380890f470102a840d87ef324d17">00494</a>         std::ifstream* <a class="code" href="classOgre_1_1FileStreamDataStream.html#af68c380890f470102a840d87ef324d17" title="Reference to source file stream (read-only)">mFStreamRO</a>;
<a name="l00496"></a><a class="code" href="classOgre_1_1FileStreamDataStream.html#a6479abd94319810a677b2a60e810b08f">00496</a>         std::fstream* <a class="code" href="classOgre_1_1FileStreamDataStream.html#a6479abd94319810a677b2a60e810b08f" title="Reference to source file stream (read-write)">mFStream</a>;
<a name="l00497"></a><a class="code" href="classOgre_1_1FileStreamDataStream.html#ac94f4c554c81b10fe8c97bc02132ffcf">00497</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1FileStreamDataStream.html#ac94f4c554c81b10fe8c97bc02132ffcf">mFreeOnClose</a>;  
<a name="l00498"></a>00498 
<a name="l00499"></a>00499         <span class="keywordtype">void</span> determineAccess();
<a name="l00500"></a>00500     <span class="keyword">public</span>:
<a name="l00506"></a>00506         <a class="code" href="classOgre_1_1FileStreamDataStream.html" title="Common subclass of DataStream for handling data from std::basic_istream.">FileStreamDataStream</a>(std::ifstream* s, 
<a name="l00507"></a>00507             <span class="keywordtype">bool</span> freeOnClose = <span class="keyword">true</span>);
<a name="l00513"></a>00513         <a class="code" href="classOgre_1_1FileStreamDataStream.html" title="Common subclass of DataStream for handling data from std::basic_istream.">FileStreamDataStream</a>(std::fstream* s, 
<a name="l00514"></a>00514             <span class="keywordtype">bool</span> freeOnClose = <span class="keyword">true</span>);
<a name="l00515"></a>00515 
<a name="l00522"></a>00522         <a class="code" href="classOgre_1_1FileStreamDataStream.html" title="Common subclass of DataStream for handling data from std::basic_istream.">FileStreamDataStream</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00523"></a>00523             std::ifstream* s, 
<a name="l00524"></a>00524             <span class="keywordtype">bool</span> freeOnClose = <span class="keyword">true</span>);
<a name="l00525"></a>00525 
<a name="l00532"></a>00532         <a class="code" href="classOgre_1_1FileStreamDataStream.html" title="Common subclass of DataStream for handling data from std::basic_istream.">FileStreamDataStream</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00533"></a>00533             std::fstream* s, 
<a name="l00534"></a>00534             <span class="keywordtype">bool</span> freeOnClose = <span class="keyword">true</span>);
<a name="l00535"></a>00535 
<a name="l00550"></a>00550         <a class="code" href="classOgre_1_1FileStreamDataStream.html" title="Common subclass of DataStream for handling data from std::basic_istream.">FileStreamDataStream</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00551"></a>00551             std::ifstream* s, 
<a name="l00552"></a>00552             <span class="keywordtype">size_t</span> size, 
<a name="l00553"></a>00553             <span class="keywordtype">bool</span> freeOnClose = <span class="keyword">true</span>);
<a name="l00554"></a>00554 
<a name="l00569"></a>00569         <a class="code" href="classOgre_1_1FileStreamDataStream.html" title="Common subclass of DataStream for handling data from std::basic_istream.">FileStreamDataStream</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00570"></a>00570             std::fstream* s, 
<a name="l00571"></a>00571             <span class="keywordtype">size_t</span> size, 
<a name="l00572"></a>00572             <span class="keywordtype">bool</span> freeOnClose = <span class="keyword">true</span>);
<a name="l00573"></a>00573 
<a name="l00574"></a>00574         ~<a class="code" href="classOgre_1_1FileStreamDataStream.html" title="Common subclass of DataStream for handling data from std::basic_istream.">FileStreamDataStream</a>();
<a name="l00575"></a>00575 
<a name="l00578"></a>00578         <span class="keywordtype">size_t</span> read(<span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> count);
<a name="l00579"></a>00579 
<a name="l00582"></a>00582         <span class="keywordtype">size_t</span> write(<span class="keyword">const</span> <span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> count);
<a name="l00583"></a>00583 
<a name="l00586"></a>00586         <span class="keywordtype">size_t</span> readLine(<span class="keywordtype">char</span>* buf, <span class="keywordtype">size_t</span> maxCount, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; delim = <span class="stringliteral">&quot;\n&quot;</span>);
<a name="l00587"></a>00587         
<a name="l00590"></a>00590         <span class="keywordtype">void</span> skip(<span class="keywordtype">long</span> count);
<a name="l00591"></a>00591     
<a name="l00594"></a>00594         <span class="keywordtype">void</span> seek( <span class="keywordtype">size_t</span> pos );
<a name="l00595"></a>00595 
<a name="l00598"></a>00598         <span class="keywordtype">size_t</span> tell(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00599"></a>00599 
<a name="l00602"></a>00602         <span class="keywordtype">bool</span> eof(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00603"></a>00603 
<a name="l00606"></a>00606         <span class="keywordtype">void</span> close(<span class="keywordtype">void</span>);
<a name="l00607"></a>00607         
<a name="l00608"></a>00608         
<a name="l00609"></a>00609     };
<a name="l00610"></a>00610 
<a name="l00620"></a><a class="code" href="classOgre_1_1FileHandleDataStream.html">00620</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1FileHandleDataStream.html" title="Common subclass of DataStream for handling data from C-style file handles.">FileHandleDataStream</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading and writing of data.">DataStream</a>
<a name="l00621"></a>00621     {
<a name="l00622"></a>00622     <span class="keyword">protected</span>:
<a name="l00623"></a><a class="code" href="classOgre_1_1FileHandleDataStream.html#afd3bb878af2d0a10bd312f680ea38a4b">00623</a>         FILE* <a class="code" href="classOgre_1_1FileHandleDataStream.html#afd3bb878af2d0a10bd312f680ea38a4b">mFileHandle</a>;
<a name="l00624"></a>00624     <span class="keyword">public</span>:
<a name="l00626"></a>00626         <a class="code" href="classOgre_1_1FileHandleDataStream.html" title="Common subclass of DataStream for handling data from C-style file handles.">FileHandleDataStream</a>(FILE* handle, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> accessMode = READ);
<a name="l00628"></a>00628         <a class="code" href="classOgre_1_1FileHandleDataStream.html" title="Common subclass of DataStream for handling data from C-style file handles.">FileHandleDataStream</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, FILE* handle, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> accessMode = READ);
<a name="l00629"></a>00629         ~<a class="code" href="classOgre_1_1FileHandleDataStream.html" title="Common subclass of DataStream for handling data from C-style file handles.">FileHandleDataStream</a>();
<a name="l00630"></a>00630 
<a name="l00633"></a>00633         <span class="keywordtype">size_t</span> read(<span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> count);
<a name="l00634"></a>00634 
<a name="l00637"></a>00637         <span class="keywordtype">size_t</span> write(<span class="keyword">const</span> <span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> count);
<a name="l00638"></a>00638 
<a name="l00641"></a>00641         <span class="keywordtype">void</span> skip(<span class="keywordtype">long</span> count);
<a name="l00642"></a>00642     
<a name="l00645"></a>00645         <span class="keywordtype">void</span> seek( <span class="keywordtype">size_t</span> pos );
<a name="l00646"></a>00646 
<a name="l00649"></a>00649         <span class="keywordtype">size_t</span> tell(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00650"></a>00650 
<a name="l00653"></a>00653         <span class="keywordtype">bool</span> eof(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00654"></a>00654 
<a name="l00657"></a>00657         <span class="keywordtype">void</span> close(<span class="keywordtype">void</span>);
<a name="l00658"></a>00658 
<a name="l00659"></a>00659     };
<a name="l00662"></a>00662 }
<a name="l00663"></a>00663 <span class="preprocessor">#endif</span>
<a name="l00664"></a>00664 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
